#include <memory.h>		 /* for memcpy() */
#include "md5.h"

/*
 * Update context to reflect the concatenation of another buffer full
 * of bytes.
 */

void MD5Update(MD5_CTX *ctx, unsigned char *buf, unsigned len)
{
	uint32 t;

	/* Update bitcount */

	t = ctx->bits[0];
	if ((ctx->bits[0] = t + ((uint32) len << 3)) < t)
		ctx->bits[1]++; 	/* Carry from low to high */
	ctx->bits[1] += len >> 29;

	t = (t >> 3) & 0x3f;	/* Bytes already in shsInfo->data */

	/* Handle any leading odd-sized chunks */

	if (t) 
	{
		unsigned char *p = (unsigned char *) ctx->in + t;

		t = 64 - t;
		if (len < t) 
		{
			memcpy(p, buf, len);
			return;
		}

		memcpy(p, buf, t);
		MD5Reorder(ctx->in, 16);
		MD5Transform(ctx->buf, (uint32 *) ctx->in);
		buf += t;
		len -= t;
    	}
    	/* Process data in 64-byte chunks */

	while (len >= 64) 
	{
		memcpy(ctx->in, buf, 64);
		MD5Reorder(ctx->in, 16);
		MD5Transform(ctx->buf, (uint32 *) ctx->in);
		buf += 64;
		len -= 64;
	}

	/* Handle any remaining bytes of data. */

	memcpy(ctx->in, buf, len);
}


